#version 450

layout(location = 0) out vec4 color;
//layout(location = 1) in vec3 normal;
layout (location = 0) in vec3 in_normal;
layout (location = 1) in vec3 in_pos;

layout(binding = 0) uniform CameraBuffer 
{
	vec4 colVal;
	vec4 camPos;
	mat4 worldTransform;
	mat4 viewTransform;
}ubo;


layout(binding = 1) uniform DirectionalLight 
{
	vec3 colVal;
	vec3 dir;
} dirLight;

layout(binding = 2) uniform PointLight 
{
	vec3 colVal;
	vec3 pos;
	vec3 atten;
} pointLight;

void main() {
	vec3 diffuse = dirLight.colVal*clamp(dot(-in_normal,dirLight.dir),0.0,1.0);

	
	// Phong Shading
	vec3 lightDir = normalize(pointLight.pos-in_pos);
	vec3 viewDir = normalize(ubo.camPos.xyz-	in_pos);
	vec3 refl = reflect(-lightDir,in_normal);
	float intensity = clamp(dot(viewDir,refl),0.0,1.0);
	
	vec3 specular = pointLight.colVal * intensity;
	vec3 light = diffuse + specular;
	vec3 outCol = ubo.colVal.xyz * light;
	color = vec4(outCol,1);//vec4(ubo.colVal);
}