#version 450

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout (location = 0) out vec3 out_normal;
layout (location = 1) out vec3 out_pos;

layout(binding = 0) uniform CameraBuffer
{
	vec4 colVal;
	vec4 camPos;
	mat4 worldTransform;
	mat4 viewTransform;
}ubo;

layout(binding = 1) uniform DirectionalLight
{
	vec3 colVal;
	vec3 dir;
} dirLight;

layout(binding = 2) uniform PointLight
{
	vec3 colVal;
	vec3 pos;
	vec3 atten;
} pointLight;

void main() {
	mat4 transform = ubo.viewTransform * ubo.worldTransform;
    gl_Position = transform*vec4(position, 1.0);
	out_normal =  normal;
	out_pos = (ubo.worldTransform*vec4(position, 1.0)).xyz;
}
