#version 450
#extension GL_EXT_debug_printf : enable

#define POINTLIGHT_COUNT 2
#define DIRLIGHT_COUNT 2

layout(location = 0) out vec4 color;
layout (location = 0) in vec4 in_color;

struct Material
{
	float ka;
	float kd;
	float ks;
	float alpha;
};

struct DirLight
{
	vec3 colVal;
	vec3 dir;
};

struct PointLight
{
	vec3 colVal;
	vec3 pos;
	vec3 atten;
};

layout(binding = 0) uniform CameraBuffer 
{
	vec4 colVal;
	vec4 camPos;
	mat4 worldTransform;
	mat4 viewTransform;
	Material m;
	mat4 normTransform;
}ubo;


int dlc = DIRLIGHT_COUNT;
layout(binding = 1) uniform DL 
{
	DirLight[DIRLIGHT_COUNT] dl;
} dirLight;


int plc = POINTLIGHT_COUNT;
layout(binding = 2) uniform PL 
{
	PointLight[POINTLIGHT_COUNT] pl;
} pointLight;

void main() {
	color = in_color;
}