#version 450

#define POINTLIGHT_COUNT 2
#define DIRLIGHT_COUNT 2

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout (location = 0) out vec3 out_normal;
layout (location = 1) out vec3 out_pos;

struct Material
{
	float ka;
	float kd;
	float ks;
	float alpha;
};

struct DirLight
{
	vec3 colVal;
	vec3 dir;
};
struct PointLight
{
	vec3 colVal;
	vec3 pos;
	vec3 atten;
};


layout(binding = 0) uniform CameraBuffer
{
	vec4 colVal;
	vec4 camPos;
	mat4 worldTransform;
	mat4 viewTransform;
	Material m;
	mat4 normTransform;
	float lightMult;
}ubo;


int dlc = DIRLIGHT_COUNT;
layout(binding = 1) uniform DL
{
	DirLight[DIRLIGHT_COUNT] dl;
} dirLight;


int plc = POINTLIGHT_COUNT;
layout(binding = 2) uniform PL
{
	PointLight[POINTLIGHT_COUNT] pl;
} pointLight;

void main() {
	mat4 transform = ubo.viewTransform * ubo.worldTransform;
	out_normal = (ubo.normTransform * vec4(normal,1.0)).xyz;
	out_pos = (ubo.worldTransform*vec4(position, 1.0)).xyz;
  gl_Position = transform*vec4(position, 1.0);
}
