#version 450

#define POINTLIGHT_COUNT 2
#define DIRLIGHT_COUNT 2

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal2;

layout(location = 2) in float boneCount;
layout(location = 3) in vec4 bones;
layout(location = 4) in vec4 weights;

layout (location = 0) out vec3 out_normal;
layout (location = 1) out vec3 out_pos;

struct Material 
{
	float ka;
	float kd;
	float ks;
	float alpha;
};

struct DirLight
{
	vec3 colVal;
	vec3 dir;
};

struct PointLight
{
	vec3 colVal;
	vec3 pos;
	vec3 atten;
};

struct Bone
{
	mat4 invBinding;
};

layout(binding = 0) uniform CameraBuffer
{
	vec4 colVal;
	vec4 camPos;
	mat4 worldTransform;
	mat4 viewTransform;
	Material m;
	mat4 normTransform;
}ubo;

layout(binding = 4) uniform BB
{
	Bone[255] bonesArr;
} bonesField;

void main() {
	uint i1 = uint(bones.x);
	Bone b1 = bonesField.bonesArr[i1];
	float w1 = weights.x;
	uint i2 = uint(bones.y);
	Bone b2 = bonesField.bonesArr[i2];
	float w2 = weights.y;
	uint i3 = uint(bones.z);
	Bone b3 = bonesField.bonesArr[i3];
	float w3 = weights.z;
	uint i4 = uint(bones.a);
	Bone b4 = bonesField.bonesArr[i4];
	float w4 = weights.a;
	//bones_decyphered = ivec4(i1, i2, i3, i4);
	mat4 m = b1.invBinding * w1
		+ b2.invBinding * w2
		+ b3.invBinding * w3
		+ b4.invBinding * w4;

	vec4 inpos4 = vec4(position, 1.0);
	vec4 outpos = m * inpos4;/*
		w1 * (b1.invBinding * inpos4) +
		w2 * (b2.invBinding * inpos4)
		;*/
	out_normal = (ubo.normTransform * vec4(normal2, 1.0)).xyz;
	out_pos = (m * vec4(weights.xyz,1.0)).xyz;//(ubo.worldTransform * vec4(position, 1.0)).xyz;

	mat4 transform = ubo.viewTransform * ubo.worldTransform;
	gl_Position = transform * m * inpos4;
	return;
}
