#version 450

layout(location = 0) out vec4 color;
layout(location = 0) in vec3 in_normal;
layout(location = 1) in vec3 in_pos;


struct Material
{
	float ka;
	float kd;
	float ks;
	float alpha;
};

layout(binding = 0) uniform CameraBuffer
{
	vec4 colVal;
	vec4 camPos;
	mat4 worldTransform;
	mat4 viewTransform;
	Material m;
	mat4 normTransform;
}ubo;

layout(binding = 1) uniform sampler2D diffuse_texture;


void main() {
	
	vec4 texCol = texture(diffuse_texture, in_pos.xy).rgba;
	color = texCol *ubo.colVal;//vec4(1.0,0.0,0.0,1.0);
	if (texCol.b+texCol.r+texCol.g < 0.2)
	{
		discard;
	}
}